import {URI}from'@vscode-alt/monaco-editor/esm/vs/base/common/uri.js';class IdObject {
    _id;
    static _n = 0;
    static mixin(object) {
        object._id = IdObject._n++;
        return object;
    }
}
// needed
var SuggestDataDtoField;
(function (SuggestDataDtoField) {
    SuggestDataDtoField["label"] = "a";
    SuggestDataDtoField["kind"] = "b";
    SuggestDataDtoField["detail"] = "c";
    SuggestDataDtoField["documentation"] = "d";
    SuggestDataDtoField["sortText"] = "e";
    SuggestDataDtoField["filterText"] = "f";
    SuggestDataDtoField["preselect"] = "g";
    SuggestDataDtoField["insertText"] = "h";
    SuggestDataDtoField["insertTextRules"] = "i";
    SuggestDataDtoField["range"] = "j";
    SuggestDataDtoField["commitCharacters"] = "k";
    SuggestDataDtoField["additionalTextEdits"] = "l";
    SuggestDataDtoField["command"] = "m";
    SuggestDataDtoField["kindModifier"] = "n";
    // to merge into label
    SuggestDataDtoField["label2"] = "o";
})(SuggestDataDtoField || (SuggestDataDtoField = {}));
var SuggestResultDtoField;
(function (SuggestResultDtoField) {
    SuggestResultDtoField["defaultRanges"] = "a";
    SuggestResultDtoField["completions"] = "b";
    SuggestResultDtoField["isIncomplete"] = "c";
    SuggestResultDtoField["duration"] = "d";
})(SuggestResultDtoField || (SuggestResultDtoField = {}));
function reviveWorkspaceEditDto(data) {
    if (data && data.edits) {
        for (const edit of data.edits) {
            if (typeof edit.resource === 'object') {
                edit.resource = URI.revive(edit.resource);
            }
            else {
                edit.newUri = URI.revive(edit.newUri);
                edit.oldUri = URI.revive(edit.oldUri);
            }
        }
    }
    return data;
}
var ObjectIdentifier;
(function (ObjectIdentifier) {
    ObjectIdentifier.name = '$ident';
    function mixin(obj, id) {
        Object.defineProperty(obj, ObjectIdentifier.name, { value: id, enumerable: true });
        return obj;
    }
    ObjectIdentifier.mixin = mixin;
    function of(obj) {
        return obj[ObjectIdentifier.name];
    }
    ObjectIdentifier.of = of;
})(ObjectIdentifier || (ObjectIdentifier = {}));export{IdObject,ObjectIdentifier,SuggestDataDtoField,SuggestResultDtoField,reviveWorkspaceEditDto};