/**
 * Returns a {@link Promise} and a function. The {@link Promise} blocks untils the returned function is called.
 *
 * @internal
 */
function createBarrier() {
    let done;
    const wait = new Promise(resolve => (done = resolve));
    return { wait, done };
}export{createBarrier};